#!/usr/bin/perl -w

use strict;

my %known=();

sub critical_name()
{
  my $cycle=$_[0];

  defined($known{$cycle}) and return $known{$cycle};

  my @result=`echo "Cycle: $cycle" | \
    /srv/jenkins-workspace/JOB-prepare-binaries-master/classify`;

  if(!scalar(@result))
  {
    warn "classify failed at $cycle\n";
    return "unknown";
  }

  @result=grep(!/^\s/, @result);

  (scalar(@result)==1) or die "Ambiguous output from classify\n";
  chomp($result[0]);

  my $c=lc($result[0]);
  $known{$cycle}=$c;

  return $c;
}

while(<>)
{
  chomp;
  my $line=$_;
  (/^(.+);(.+);(.+);(.+);critical$/) or die "Invalid input $_\n";

  my $cycle=$4;

  $cycle =~ s/DpDatas/PosR/g;
  $cycle =~ s/DpDatad/PodR/g;

  print "$line;".&critical_name($cycle)."\n";
}

