#!/usr/bin/perl -w

use strict;

sub uniproc_name()
{
  my @cycle=split(/\s/, $_[0]);

  if($cycle[0] =~ /^(Pos..|Rfi)$/)
  {
    if(scalar(@cycle)==2)
    {
      return "coWW" if($_[0] =~ /^PosWW Ws(i|e)$/);
      return "coRW1" if($_[0] eq "PosRW Rfi" || $_[0] eq "Rfi PosRW");
      return "coWR" if($_[0] =~ /^(PosWR|Rfi) Fr(i|e)$/);
    }
    elsif(scalar(@cycle)==3)
    {
      return "coRW2" if($_[0] eq "PosRW Wse Rfe");
      return "coRR" if($_[0] eq "PosRR Fre Rfe");
    }

    return "unknown";
  }
  else
  {
    my $front=shift @cycle;
    push @cycle, $front;

    return &uniproc_name(join(" ", @cycle));
  }
}

while(<>)
{
  chomp;
  my $line=$_;
  (/^(.+);(.+);(.+);(.+);uniproc$/) or die "Invalid input $_\n";

  my $cycle=$4;

  $cycle =~ s/(Lw)?Syncs/Pos/g;
  $cycle =~ s/DpDatas/PosR/g;
  ($cycle =~ /(Pos|Rfi)/) or die "Not a valid uniproc cycle: $cycle\n";

  print "$line;".&uniproc_name($cycle)."\n";
}

