#!/bin/bash

MOLE_HOME=`cd \`dirname $0\` > /dev/null 2>&1 ; echo $PWD`

export PKG=$1

if [ ! -f cycles-proc/$PKG/classify-done ] ; then
  echo "classify not done"
  exit 1
fi
if [ ! -d cycles/$PKG ] ; then
  echo "goto-instrument output not available"
  exit 1
fi

cd cycles-proc/$PKG

rm -rf mole-pkg
mkdir mole-pkg
if ls /srv/jenkins-workspace/goto-cc-$PKG/$PKG_*z > /dev/null 2>&1 ; then
  cp /srv/jenkins-workspace/goto-cc-$PKG/$PKG_*z mole-pkg/
fi
if ls /srv/jenkins-workspace/goto-cc-$PKG/$PKG_*.bz2 > /dev/null 2>&1 ; then
  cp /srv/jenkins-workspace/goto-cc-$PKG/$PKG_*.bz2 mole-pkg/
fi
cp /srv/jenkins-workspace/goto-cc-$PKG/$PKG_*.dsc mole-pkg/
cd mole-pkg
dpkg-source --no-check -x *.dsc > /dev/null
cd ..
export PKG_VERSION="`grep "^Version:" mole-pkg/*.dsc | sed 's/^Version:[[:space:]]*//'`"

cat critical-classified.txt uniproc-classified.txt | \
  cut -f6 -d';' | sort | uniq -c | sort -gr | \
while read c s ; do
  echo -n "$s | $c | "
  
  cat critical-classified.txt uniproc-classified.txt | grep ";$s$" | \
    cut -f3-4 -d';' | $MOLE_HOME/mole-source-transform.pl > sources.txt
  head -n 1 sources.txt

  mv sources.txt mole-source-links-$s.txt
  gzip mole-source-links-$s.txt
done > mole-report.txt

rm -rf mole-pkg

